# opentl::input::FirewireCamera Class Reference

Interface class with factory functions for Firewire cameras. More...

Inherits opentl::input::ImageSensor.

Inherited by opentl::input::LinuxDC1394Camera, and opentl::input::WindowsCMU1394Camera.

List of all members.

## Public Types
## Public Member Functions
| FirewireCamera ()
virtual void | getCaptureParameters (int &width, int &height, opentl::core::cvdata::Image::ColorChannels &channels, opentl::core::cvdata::Image::BitsPerChannel &bpc)=0
| Returns the current capture parameters. Hint: open() needs to be called in advance.
virtual | ~FirewireCamera ()
## Static Public Member Functions
static FirewireCamera * | createFirewireCamera (int cameraNumber=0)
| Factory function to create a FirewireCamera instance.
static void | deleteFirewireCamera (FirewireCamera *camera)
| Destroys a camera object by calling its virtual destructor.
static int | getNumberOfFirewireCameras ()
| Return the number of connected Firewire Cameras.
static const std::string & | getVideoFormatString (Format format)
| Return a string for a given format enum variable.
static const std::string & | getVideoFramerateString (Framerate framerate)
| Return a string for a given framerate enum variable.
static const std::string & | getVideoModeString (Mode mode)
| Return a string for a given mode enum variable.
## Protected Attributes
int | cameraIndex
| Index of the camera.
bool | capturing
| Indicates, if we are in capture state or not.
opentl::core::cvdata::Image * | currentFrame
| The grabbed frame.
opentl::core::cvdata::Image * | currentRGBFrame
| The grabbed frame as a RGB image.
bool | isOpened
| Indicates, if the camera is opened.

## Detailed Description

Interface class with factory functions for Firewire cameras.

Author:
  Martin Wojtczyk <wojtczyk@in.tum.de>

FirewireCamera is the base class for operating system specific implementations of Firewire Cameras. Use this class to instantiate FirewireCamera Objects.

## Member Enumeration Documentation

enum opentl::input::FirewireCamera::Color

Enumerator:

  COLOR_RGB |
  COLOR_GREYSCALE |
  COLOR_YUV422 |

enum opentl::input::FirewireCamera::Format

Enumerator:

  FORMAT0 |
  FORMAT1 |
  FORMAT2 |
  FORMAT7 |

enum opentl::input::FirewireCamera::Framerate

Constants.

Enumerator:

  FRAMERATE_1_875 |
  FRAMERATE_3_75 |
  FRAMERATE_7_5 |
  FRAMERATE_15 |
  FRAMERATE_30 |
  FRAMERATE_60 |
  FRAMERATE_120 |
  FRAMERATE_240 |

enum opentl::input::FirewireCamera::Mode

Enumerator:

  MODE0 |
  MODE1 |
  MODE_160x120_YUV444 |
  MODE_320x240_YUV422 |
  MODE_640x480_YUV411 |
  MODE_640x480_YUV422 |
  MODE_640x480_RGB |
  MODE_640x480_MONO8 |
  MODE_640x480_MONO16 |
  MODE_800x600_YUV422 |
  MODE_800x600_RGB |
  MODE_800x600_MONO8 |
  MODE_1024x768_YUV422 |
  MODE_1024x768_RGB |
  MODE_1024x768_MONO8 |
  MODE_800x600_MONO16 |
  MODE_1024x768_MONO16 |
  MODE_1280x960_YUV422 |
  MODE_1280x960_RGB |
  MODE_1280x960_MONO8 |
  MODE_1600x1200_YUV422 |
  MODE_1600x1200_RGB |
  MODE_1600x1200_MONO8 |
  MODE_1280x960_MONO16 |
  MODE_1600x1200_MONO16 |
  WIN32 |
  MODE_FORMAT7_0 |
  MODE_FORMAT7_1 |
  MODE_FORMAT7_2 |
  MODE_FORMAT7_3 |
  MODE_FORMAT7_4 |
  MODE_FORMAT7_5 |
  MODE_FORMAT7_6 |
  endif |

enum opentl::input::FirewireCamera::OfflineParameters

Enumerator:

  VideoFramerate | (opentl::input::FirewireCamera::Framerate) Framerate
  VideoMode | (opentl::input::FirewireCamera::Mode) VideoMode
  VideoFormat | (opentl::input::FirewireCamera::Format) VideoFormat
  OFFLINE_COUNT |

Reimplemented from opentl::input::ImageSensor.

enum opentl::input::FirewireCamera::OnlineParameters

Enumerator:

  BayerFilter | (cvprocess::Bayer::Filter) BayerFilter
  GainAuto | (bool) Enable Auto Gain
  IrisAuto | (bool) Enable Auto Iris
  Shutter | (int) Shutter
  ShutterAuto | (bool) Enable Auto Shutter
  TriggerDelay | TriggerDelay (not yet supported).
  TriggerSource | TriggerSource (not yet supported).
  WhiteBalance | (opentl::math::Vector2) White Balance
  WhiteBalanceAuto | (bool) Enable White Balance Auto
  TriggerMode | (unsigned int) TriggerMode
  WhiteBalanceOnePush | (bool) enable white balance one push
  ONLINE_COUNT |

Reimplemented from opentl::input::ImageSensor.

## Constructor & Destructor Documentation

opentl::input::FirewireCamera::FirewireCamera | ( |  | ) |

virtual opentl::input::FirewireCamera::~FirewireCamera | ( |  | ) | `[virtual]`

## Member Function Documentation

static FirewireCamera* opentl::input::FirewireCamera::createFirewireCamera | ( | int | cameraNumber = `0` | ) | `[static]`

Factory function to create a FirewireCamera instance.

Parameters:

  | index | of the camera to connect to

Returns:
  The created Camera object.

static void opentl::input::FirewireCamera::deleteFirewireCamera | ( | FirewireCamera * | camera | ) | `[static]`

Destroys a camera object by calling its virtual destructor.

Parameters:

  | camera | The camera object to destroy.

virtual void opentl::input::FirewireCamera::getCaptureParameters | ( | int & | width,
|  | int & | height,
|  | opentl::core::cvdata::Image::ColorChannels & | channels,
|  | opentl::core::cvdata::Image::BitsPerChannel & | bpc |
| ) |  |  | `[pure virtual]`

Returns the current capture parameters. Hint: open() needs to be called in advance.

Implemented in opentl::input::LinuxDC1394Camera, and opentl::input::WindowsCMU1394Camera.

static int opentl::input::FirewireCamera::getNumberOfFirewireCameras | ( |  | ) | `[static]`

Return the number of connected Firewire Cameras.

static const std::string& opentl::input::FirewireCamera::getVideoFormatString | ( | Format | format | ) | `[static]`

Return a string for a given format enum variable.

Parameters:

  | format | the value for the string determination.

static const std::string& opentl::input::FirewireCamera::getVideoFramerateString | ( | Framerate | framerate | ) | `[static]`

Return a string for a given framerate enum variable.

Parameters:

  | framerate | the value for the string determination.

static const std::string& opentl::input::FirewireCamera::getVideoModeString | ( | Mode | mode | ) | `[static]`

Return a string for a given mode enum variable.

Parameters:

  | mode | the value for the string determination.

## Member Data Documentation

int opentl::input::FirewireCamera::cameraIndex`[protected]`

Index of the camera.

bool opentl::input::FirewireCamera::capturing`[protected]`

Indicates, if we are in capture state or not.

opentl::core::cvdata::Image* opentl::input::FirewireCamera::currentFrame`[protected]`

The grabbed frame.

opentl::core::cvdata::Image* opentl::input::FirewireCamera::currentRGBFrame`[protected]`

The grabbed frame as a RGB image.

bool opentl::input::FirewireCamera::isOpened`[protected]`

Indicates, if the camera is opened.